SENDMAIL(8)                 System Manager's Manual                SENDMAIL(8)



NNAAMMEE
       sendmail - an electronic mail transport agent

SSYYNNOOPPSSIISS
       sseennddmmaaiill [_f_l_a_g_s] [_a_d_d_r_e_s_s _._._.]
       nneewwaalliiaasseess
       mmaaiillqq [--vv]
       hhoossttssttaatt
       ppuurrggeessttaatt
       ssmmttppdd

DDEESSCCRRIIPPTTIIOONN
       SSeennddmmaaiill sends a message to one or more _r_e_c_i_p_i_e_n_t_s_, routing the message
       over whatever networks are necessary.  SSeennddmmaaiill does internetwork  for-
       warding as necessary to deliver the message to the correct place.

       SSeennddmmaaiill  is  not  intended as a user interface routine; other programs
       provide user-friendly front ends; sseennddmmaaiill is used only to deliver pre-
       formatted messages.

       With  no  flags, sseennddmmaaiill reads its standard input up to an end-of-file
       or a line consisting only of a single dot and sends a copy of the  mes-
       sage  found  there  to  all of the addresses listed.  It determines the
       network(s) to use based on the syntax and contents of the addresses.

       Local addresses are looked up in  a  file  and  aliased  appropriately.
       Aliasing  can  be  prevented by preceding the address with a backslash.
       Beginning with 8.10, the sender is included in  any  alias  expansions,
       e.g.,  if  `john'  sends to `group', and `group' includes `john' in the
       expansion, then the letter will also be delivered to `john'.

   PPaarraammeetteerrss
       --AAcc    Use submit.cf even if the operation mode does  not  indicate  an
              initial mail submission.

       --AAmm    Use  sendmail.cf even if the operation mode indicates an initial
              mail submission.

       --BB_t_y_p_e Set the body type to _t_y_p_e.  Current legal  values  are  7BIT  or
              8BITMIME.

       --bbaa    Go  into  ARPANET  mode.  All input lines must end with a CR-LF,
              and all messages will be generated with  a  CR-LF  at  the  end.
              Also,  the ``From:'' and ``Sender:'' fields are examined for the
              name of the sender.

       --bbdd    Run as a daemon.  SSeennddmmaaiill will fork and run in background  lis-
              tening on socket 25 for incoming SMTP connections.  This is nor-
              mally run from /etc/rc.

       --bbDD    Same as --bbdd except runs in foreground.

       --bbhh    Print the persistent host status database.

       --bbHH    Purge expired entries from the persistent host status database.

       --bbii    Initialize the alias database.

       --bbmm    Deliver mail in the usual way (default).

       --bbpp    Print a listing of the queue(s).

       --bbPP    Print number of entries in the  queue(s);  only  available  with
              shared memory support.

       --bbss    Use  the  SMTP protocol as described in RFC821 on standard input
              and output.  This flag implies all the  operations  of  the  --bbaa
              flag that are compatible with SMTP.

       --bbtt    Run  in  address test mode.  This mode reads addresses and shows
              the steps in parsing; it is  used  for  debugging  configuration
              tables.

       --bbvv    Verify  names only - do not try to collect or deliver a message.
              Verify mode is normally used for  validating  users  or  mailing
              lists.

       --CC_f_i_l_e Use   alternate  configuration  file.   SSeennddmmaaiill  gives  up  any
              enhanced (set-user-ID or set-group-ID) privileges if  an  alter-
              nate configuration file is specified.

       --DD _l_o_g_f_i_l_e
              Send  debugging output to the indicated log file instead of std-
              out.

       --dd_c_a_t_e_g_o_r_y.._l_e_v_e_l_._._.
              Set the debugging flag  for  _c_a_t_e_g_o_r_y  to  _l_e_v_e_l.   _C_a_t_e_g_o_r_y  is
              either  an  integer or a name specifying the topic, and _l_e_v_e_l an
              integer  specifying  the  level  of  debugging  output  desired.
              Higher  levels  generally  mean more output.  More than one flag
              can be specified by separating them  with  commas.   A  list  of
              numeric debugging categories can be found in the TRACEFLAGS file
              in the sendmail source distribution.
              The option --dd00..11 prints the version of sseennddmmaaiill and the  options
              it was compiled with.
              Most  other  categories are only useful with, and documented in,
              sseennddmmaaiill's source code.

       --FF_f_u_l_l_n_a_m_e
              Set the full name of the sender.

       --ff_n_a_m_e Sets the name of the ``from'' person (i.e., the envelope  sender
              of the mail).  This address may also be used in the From: header
              if that header is missing during initial submission.  The  enve-
              lope sender address is used as the recipient for delivery status
              notifications and may also appear in a Return-Path: header.   --ff
              should only be used by ``trusted'' users (normally _r_o_o_t, _d_a_e_m_o_n,
              and _n_e_t_w_o_r_k) or if the person you are trying to  become  is  the
              same  as  the  person  you are.  Otherwise, an X-Authentication-
              Warning header will be added to the message.

       --GG     Relay (gateway) submission of a message, e.g., when rrmmaaiill  calls
              sseennddmmaaiill ..

       --hh_N    Set the hop count to _N.  The hop count is incremented every time
              the mail is processed.  When it reaches a  limit,  the  mail  is
              returned  with an error message, the victim of an aliasing loop.
              If  not  specified,  ``Received:''  lines  in  the  message  are
              counted.

       --ii     Ignore  dots  alone on lines by themselves in incoming messages.
              This should be set if you are reading data from a file.

       --LL _t_a_g Set the identifier used in syslog messages to the supplied _t_a_g.

       --NN _d_s_n Set delivery status notification conditions to _d_s_n, which can be
              `never'  for  no  notifications or a comma separated list of the
              values `failure' to be notified if delivery failed,  `delay'  to
              be notified if delivery is delayed, and `success' to be notified
              when the message is successfully delivered.

       --nn     Don't do aliasing.

       --OO _o_p_t_i_o_n=_v_a_l_u_e
              Set option _o_p_t_i_o_n to the specified _v_a_l_u_e.  This form  uses  long
              names.  See below for more details.

       --oo_x _v_a_l_u_e
              Set  option  _x  to  the  specified _v_a_l_u_e.  This form uses single
              character names only.  The short names are not described in this
              manual  page;  see the _S_e_n_d_m_a_i_l _I_n_s_t_a_l_l_a_t_i_o_n _a_n_d _O_p_e_r_a_t_i_o_n _G_u_i_d_e
              for details.

       --pp_p_r_o_t_o_c_o_l
              Set the name of the protocol used to receive the message.   This
              can be a simple protocol name such as ``UUCP'' or a protocol and
              hostname, such as ``UUCP:ucbvax''.

       --qq[_t_i_m_e]
              Process saved messages in the queue at given intervals.  If _t_i_m_e
              is  omitted,  process the queue once.  _T_i_m_e is given as a tagged
              number, with `s' being seconds, `m' being minutes (default), `h'
              being  hours, `d' being days, and `w' being weeks.  For example,
              `-q1h30m' or `-q90m' would both set  the  timeout  to  one  hour
              thirty  minutes.   By  default,  sseennddmmaaiill  will run in the back-
              ground.  This option can be used safely with --bbdd.

       --qqpp[_t_i_m_e]
              Similar to --qq_t_i_m_e, except that instead of periodically forking a
              child  to  process the queue, sendmail forks a single persistent
              child for each queue  that  alternates  between  processing  the
              queue and sleeping.  The sleep time is given as the argument; it
              defaults to 1 second.  The process will always sleep at least  5
              seconds if the queue was empty in the previous queue run.

       --qqf    Process  saved messages in the queue once and do not fork(), but
              run in the foreground.

       --qqG_n_a_m_e
              Process jobs in queue group called _n_a_m_e only.

       --qq[_!]I_s_u_b_s_t_r
              Limit processed jobs to those containing _s_u_b_s_t_r as  a  substring
              of the queue id or not when _!  is specified.

       --qq[_!]Q_s_u_b_s_t_r
              Limit  processed jobs to quarantined jobs containing _s_u_b_s_t_r as a
              substring of the quarantine reason or not when _!  is specified.

       --qq[_!]R_s_u_b_s_t_r
              Limit processed jobs to those containing _s_u_b_s_t_r as  a  substring
              of one of the recipients or not when _!  is specified.

       --qq[_!]S_s_u_b_s_t_r
              Limit  processed  jobs to those containing _s_u_b_s_t_r as a substring
              of the sender or not when _!  is specified.

       --QQ[reason]
              Quarantine a normal queue items with the given reason or unquar-
              antine  quarantined  queue  items  if  no reason is given.  This
              should only be used with some sort of  item  matching  using  as
              described above.

       --RR _r_e_t_u_r_n
              Set  the  amount  of  the  message to be returned if the message
              bounces.  The _r_e_t_u_r_n parameter  can  be  `full'  to  return  the
              entire  message  or  `hdrs'  to return only the headers.  In the
              latter case also local bounces return only the headers.

       --rr_n_a_m_e An alternate and obsolete form of the --ff flag.

       --tt     Read message for recipients.  To:, Cc:, and Bcc: lines  will  be
              scanned  for recipient addresses.  The Bcc: line will be deleted
              before transmission.

       --VV _e_n_v_i_d
              Set the original envelope id.  This is propagated across SMTP to
              servers that support DSNs and is returned in DSN-compliant error
              messages.

       --vv     Go into verbose mode.  Alias expansions will be announced, etc.

       --XX _l_o_g_f_i_l_e
              Log all traffic in and out of mailers in the indicated log file.
              This  should  only be used as a last resort for debugging mailer
              bugs.  It will log a lot of data very quickly.

       ----     Stop processing command flags and use the rest of the  arguments
              as addresses.

   OOppttiioonnss
       There  are  also  a number of processing options that may be set.  Nor-
       mally these will only be used by a system administrator.   Options  may
       be  set either on the command line using the --oo flag (for short names),
       the --OO flag (for long names), or in the configuration file.  This is  a
       partial  list  limited to those options that are likely to be useful on
       the command line and only shows the long names;  for  a  complete  list
       (and  details),  consult the _S_e_n_d_m_a_i_l _I_n_s_t_a_l_l_a_t_i_o_n _a_n_d _O_p_e_r_a_t_i_o_n _G_u_i_d_e.
       The options are:

       AliasFile=_f_i_l_e
              Use alternate alias file.

       HoldExpensive
              On mailers that are  considered  ``expensive''  to  connect  to,
              don't initiate immediate connection.  This requires queueing.

       CheckpointInterval=_N
              Checkpoint  the  queue  file after every _N successful deliveries
              (default 10).  This avoids excessive duplicate  deliveries  when
              sending to long mailing lists interrupted by system crashes.

       DeliveryMode=_x
              Set the delivery mode to _x.  Delivery modes are `i' for interac-
              tive (synchronous) delivery, `b' for  background  (asynchronous)
              delivery, `q' for queue only - i.e., actual delivery is done the
              next time the queue is run, and `d' for deferred - the  same  as
              `q'  except that database lookups for maps which have set the -D
              option (default for the host map) are avoided.

       ErrorMode=_x
              Set error processing to mode _x.  Valid modes  are  `m'  to  mail
              back  the error message, `w' to ``write'' back the error message
              (or mail it back if the sender is not logged in), `p'  to  print
              the  errors  on  the terminal (default), `q' to throw away error
              messages (only exit status is returned), and `e' to  do  special
              processing  for  the BerkNet.  If the text of the message is not
              mailed back by modes `m' or `w' and if the sender  is  local  to
              this  machine,  a  copy  of  the message is appended to the file
              _d_e_a_d_._l_e_t_t_e_r in the sender's home directory.

       SaveFromLine
              Save UNIX-style From lines at the front of messages.

       MaxHopCount=_N
              The maximum number of times a  message  is  allowed  to  ``hop''
              before we decide it is in a loop.

       IgnoreDots
              Do  not  take dots on a line by themselves as a message termina-
              tor.

       SendMimeErrors
              Send error messages in MIME format.  If not set, the DSN (Deliv-
              ery Status Notification) SMTP extension is disabled.

       ConnectionCacheTimeout=_t_i_m_e_o_u_t
              Set connection cache timeout.

       ConnectionCacheSize=_N
              Set connection cache size.

       LogLevel=_n
              The log level.

       MeToo=_F_a_l_s_e
              Don't send to ``me'' (the sender) if I am in an alias expansion.

       CheckAliases
              Validate  the  right hand side of aliases during a newaliases(1)
              command.

       OldStyleHeaders
              If set, this message may have old style headers.   If  not  set,
              this message is guaranteed to have new style headers (i.e., com-
              mas instead of spaces between addresses).  If set,  an  adaptive
              algorithm  is used that will correctly determine the header for-
              mat in most cases.

       QueueDirectory=_q_u_e_u_e_d_i_r
              Select the directory in which to queue messages.

       StatusFile=_f_i_l_e
              Save statistics in the named file.

       Timeout.queuereturn=_t_i_m_e
              Set the timeout on undelivered messages  in  the  queue  to  the
              specified  time.   After delivery has failed (e.g., because of a
              host being down) for this amount of time, failed  messages  will
              be returned to the sender.  The default is five days.

       UserDatabaseSpec=_u_s_e_r_d_a_t_a_b_a_s_e
              If  set, a user database is consulted to get forwarding informa-
              tion.  You can consider this an adjunct to the  aliasing  mecha-
              nism,  except  that  the database is intended to be distributed;
              aliases are local to a particular host.  This may not be  avail-
              able  if  your sendmail does not have the USERDB option compiled
              in.

       ForkEachJob
              Fork each job during queue runs.  May be convenient  on  memory-
              poor machines.

       SevenBitInput
              Strip incoming messages to seven bits.

       EightBitMode=_m_o_d_e
              Set the handling of eight bit input to seven bit destinations to
              _m_o_d_e: m (mimefy) will convert to seven-bit MIME format, p (pass)
              will  pass  it  as  eight  bits  (but violates protocols), and s
              (strict) will bounce the message.

       MinQueueAge=_t_i_m_e_o_u_t
              Sets how long a job must ferment in the queue  between  attempts
              to send it.

       DefaultCharSet=_c_h_a_r_s_e_t
              Sets  the default character set used to label 8-bit data that is
              not otherwise labelled.

       DialDelay=_s_l_e_e_p_t_i_m_e
              If opening a connection fails, sleep for _s_l_e_e_p_t_i_m_e  seconds  and
              try again.  Useful on dial-on-demand sites.

       NoRecipientAction=_a_c_t_i_o_n
              Set  the behaviour when there are no recipient headers (To:, Cc:
              or Bcc:) in the message  to  _a_c_t_i_o_n:  none  leaves  the  message
              unchanged,  add-to  adds  a To: header with the envelope recipi-
              ents, add-apparently-to adds an Apparently-To: header  with  the
              envelope recipients, add-bcc adds an empty Bcc: header, and add-
              to-undisclosed adds a header  reading  `To:  undisclosed-recipi-
              ents:;'.

       MaxDaemonChildren=_N
              Sets the maximum number of children that an incoming SMTP daemon
              will allow to spawn at any time to _N.

       ConnectionRateThrottle=_N
              Sets the maximum number of connections per second  to  the  SMTP
              port to _N.

       In  aliases,  the  first  character  of a name may be a vertical bar to
       cause interpretation of the rest of the name as a command to  pipe  the
       mail  to.   It may be necessary to quote the name to keep sseennddmmaaiill from
       suppressing the blanks from between arguments.  For example,  a  common
       alias is:

              msgs: "|/usr/bin/msgs -s"

       Aliases  may also have the syntax ``:include:_f_i_l_e_n_a_m_e'' to ask sseennddmmaaiill
       to read the named file for a list of recipients.  For example, an alias
       such as:

              poets: ":include:/usr/local/lib/poets.list"

       would  read  _/_u_s_r_/_l_o_c_a_l_/_l_i_b_/_p_o_e_t_s_._l_i_s_t for the list of addresses making
       up the group.

       SSeennddmmaaiill returns an exit status describing what it did.  The codes  are
       defined in <_s_y_s_e_x_i_t_s_._h>:

       EX_OK  Successful completion on all addresses.

       EX_NOUSER
              User name not recognized.

       EX_UNAVAILABLE
              Catchall meaning necessary resources were not available.

       EX_SYNTAX
              Syntax error in address.

       EX_SOFTWARE
              Internal software error, including bad arguments.

       EX_OSERR
              Temporary operating system error, such as ``cannot fork''.

       EX_NOHOST
              Host name not recognized.

       EX_TEMPFAIL
              Message could not be sent immediately, but was queued.

       If invoked as nneewwaalliiaasseess, sseennddmmaaiill will rebuild the alias database.  If
       invoked as mmaaiillqq, sseennddmmaaiill will print the contents of the  mail  queue.
       If  invoked as hhoossttssttaatt, sseennddmmaaiill will print the persistent host status
       database.  If invoked as ppuurrggeessttaatt, sseennddmmaaiill will purge expired entries
       from  the  persistent host status database.  If invoked as ssmmttppdd, sseenndd--
       mmaaiill will act as a daemon, as if the --bbdd option were specified.

NNOOTTEESS
       sseennddmmaaiill often gets blamed for many  problems  that  are  actually  the
       result  of  other problems, such as overly permissive modes on directo-
       ries.  For this reason, sseennddmmaaiill checks the modes on system directories
       and  files  to determine if they can be trusted.  Although these checks
       can be turned off and your system security reduced by setting the DDoonntt--
       BBllaammeeSSeennddmmaaiill  option,  the  permission  problems should be fixed.  For
       more information, see:

       _h_t_t_p_:_/_/_w_w_w_._s_e_n_d_m_a_i_l_._o_r_g_/_t_i_p_s_/_D_o_n_t_B_l_a_m_e_S_e_n_d_m_a_i_l_._h_t_m_l

FFIILLEESS
       Except for the file _/_e_t_c_/_m_a_i_l_/_s_e_n_d_m_a_i_l_._c_f itself  the  following  path-
       names  are  all specified in _/_e_t_c_/_m_a_i_l_/_s_e_n_d_m_a_i_l_._c_f.  Thus, these values
       are only approximations.

        /etc/mail/aliases
              raw data for alias names

        /etc/mail/aliases.db
              data base of alias names

        /etc/mail/sendmail.cf
              configuration file

        /etc/mail/helpfile
              help file

        /etc/mail/statistics
              collected statistics

        /var/spool/mqueue/*
              temp files

SSEEEE AALLSSOO
       binmail(1),  mail(1),  rmail(1),  syslog(3),  aliases(5),  mailaddr(7),
       rc(8)

       DARPA  Internet  Request For Comments _R_F_C_8_1_9, _R_F_C_8_2_1, _R_F_C_8_2_2.  _S_e_n_d_m_a_i_l
       _I_n_s_t_a_l_l_a_t_i_o_n _a_n_d _O_p_e_r_a_t_i_o_n _G_u_i_d_e, No. 8, SMM.

       http://www.sendmail.org/

HHIISSTTOORRYY
       The sseennddmmaaiill command appeared in 4.2BSD.



                         $Date: 2007/08/02 05:42:33 $              SENDMAIL(8)
